        Device (PCI0)
        {
            Name (_HID, EisaId ("PNP0A03"))
            Name (_ADR, Zero)
            Name (_UID, One)
            Name (_BBN, Zero)
            Method (_S3D, 0, NotSerialized)
            {
                If (LEqual (OSFL, 0x02))
                {
                    Return (0x02)
                }
                Else
                {
                    Return (0x03)
                }
            }

            Device (PEGP)
            {
                Name (_ADR, 0x00030000)
                Name (_PRW, Package (0x02)
                {
                    0x09, 
                    0x05
                })
                Device (GFX0)
                {
                    Name (_ADR, Zero)
                    Name (_PRW, Package (0x02)
                    {
                        0x09, 
                        0x05
                    })
                    OperationRegion (PEGH, PCI_Config, Zero, 0x40)
                    Field (PEGH, ByteAcc, NoLock, Preserve)
                    {
                        VID0,   16, 
                        DID0,   16
                    }

                    Method (_DSM, 4, NotSerialized)
                    {
                        If (LEqual (Arg0, Buffer (0x10)
                                {
                                    /* 0000 */   0xC6, 0xB7, 0xB5, 0xA0, 0x18, 0x13, 0x1C, 0x44,
                                    /* 0008 */   0xB0, 0xC9, 0xFE, 0x69, 0x5E, 0xAF, 0x94, 0x9B
                                }))
                        {
                            If (LNotEqual (And (VID0, 0xFFFF), 0xFFFF))
                            {
                                Store (Package (0x70)
                                    {
                                        "@0,AAPL,boot-display", 
                                        Buffer (0x04)
                                        {
                                             0x01, 0x00, 0x00, 0x00
                                        }, 

                                        "@0,compatible", 
                                        Buffer (0x0B)
                                        {
                                            "ATY,Gibba"
                                        }, 

                                        "@0,connector-type", 
                                        Buffer (0x04)
                                        {
                                             0x00, 0x08, 0x00, 0x00
                                        }, 

                                        "@0,device_type", 
                                        Buffer (0x08)
                                        {
                                            "display"
                                        }, 

                                        "@0,display-type", 
                                        Buffer (0x05)
                                        {
                                            "NONE"
                                        }, 

                                        "@0,name", 
                                        Buffer (0x0B)
                                        {
                                            "ATY,Gibba"
                                        }, 

                                        "@1,compatible", 
                                        Buffer (0x0B)
                                        {
                                            "ATY,Gibba"
                                        }, 

                                        "@1,connector-type", 
                                        Buffer (0x04)
                                        {
                                             0x04, 0x00, 0x00, 0x00
                                        }, 

                                        "@1,device_type", 
                                        Buffer (0x08)
                                        {
                                            "display"
                                        }, 

                                        "@1,display-type", 
                                        Buffer (0x05)
                                        {
                                            "NONE"
                                        }, 

                                        "@1,name", 
                                        Buffer (0x0B)
                                        {
                                            "ATY,Gibba"
                                        }, 

                                        "@2,compatible", 
                                        Buffer (0x0B)
                                        {
                                            "ATY,Gibba"
                                        }, 

                                        "@2,connector-type", 
                                        Buffer (0x04)
                                        {
                                             0x04, 0x00, 0x00, 0x00
                                        }, 

                                        "@2,device_type", 
                                        Buffer (0x08)
                                        {
                                            "display"
                                        }, 

                                        "@2,display-type", 
                                        Buffer (0x05)
                                        {
                                            "NONE"
                                        }, 

                                        "@2,name", 
                                        Buffer (0x0B)
                                        {
                                            "ATY,Gibba"
                                        }, 

                                        "@3,compatible", 
                                        Buffer (0x0B)
                                        {
                                            "ATY,Gibba"
                                        }, 

                                        "@3,connector-type", 
                                        Buffer (0x04)
                                        {
                                             0x00, 0x04, 0x00, 0x00
                                        }, 

                                        "@3,device_type", 
                                        Buffer (0x08)
                                        {
                                            "display"
                                        }, 

                                        "@3,display-type", 
                                        Buffer (0x05)
                                        {
                                            "NONE"
                                        }, 

                                        "@3,name", 
                                        Buffer (0x0B)
                                        {
                                            "ATY,Gibba"
                                        }, 

                                        "@4,compatible", 
                                        Buffer (0x0B)
                                        {
                                            "ATY,Gibba"
                                        }, 

                                        "@4,connector-type", 
                                        Buffer (0x04)
                                        {
                                             0x00, 0x04, 0x00, 0x00
                                        }, 

                                        "@4,device_type", 
                                        Buffer (0x08)
                                        {
                                            "display"
                                        }, 

                                        "@4,display-type", 
                                        Buffer (0x05)
                                        {
                                            "NONE"
                                        }, 

                                        "@4,name", 
                                        Buffer (0x0B)
                                        {
                                            "ATY,Gibba"
                                        }, 

                                        "AAPL,EMC-Display-List", 
                                        Buffer (0x40)
                                        {
                                            /* 0000 */   0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                            /* 0008 */   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                            /* 0010 */   0x06, 0x10, 0x00, 0x00, 0x1B, 0x92, 0x00, 0x00,
                                            /* 0018 */   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                            /* 0020 */   0x06, 0x10, 0x00, 0x00, 0x1C, 0x92, 0x00, 0x00,
                                            /* 0028 */   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                            /* 0030 */   0x06, 0x10, 0x00, 0x00, 0x21, 0x92, 0x00, 0x00,
                                            /* 0038 */   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
                                        }, 

                                        "AAPL,aux-power-connected", 
                                        Buffer (0x04)
                                        {
                                             0x01, 0x00, 0x00, 0x00
                                        }, 

                                        "AAPL,backlight-control", 
                                        Buffer (0x04)
                                        {
                                             0x00, 0x00, 0x00, 0x00
                                        }, 

                                        "AAPL,overwrite_binimage", 
                                        Buffer (One)
                                        {
                                             0x01
                                        }, 

                                        "AAPL,slot-name", 
                                        Buffer (0x0B)
                                        {
                                            "PCIe x16-1"
                                        }, 

                                        "AAPL00,blackscreen-preferences", 
                                        Buffer (0x04)
                                        {
                                             0x00, 0x00, 0x00, 0x08
                                        }, 

                                        "AAPL01,Coherency", 
                                        Buffer (0x04)
                                        {
                                             0x02, 0x00, 0x00, 0x00
                                        }, 

                                        "AAPL01,blackscreen-preferences", 
                                        Buffer (0x04)
                                        {
                                             0x00, 0x00, 0x00, 0x08
                                        }, 

                                        "ATY,Card#", 
                                        Buffer (0x0E)
                                        {
                                            "109-B77101-00"
                                        }, 

                                        "ATY,Copyright", 
                                        Buffer (0x33)
                                        {
                                            "Copyright AMD Inc. All Rights Reserved. 2005-2008"
                                        }, 

                                        "ATY,EFICompileDate", 
                                        Buffer (0x0C)
                                        {
                                            "Oct 09 2009"
                                        }, 

                                        "ATY,EFIDispConfig", 
                                        Buffer (0x08)
                                        {
                                             0x0D, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
                                        }, 

                                        "ATY,EFIDriverType", 
                                        Buffer (One)
                                        {
                                             0x02
                                        }, 

                                        "ATY,EFIEnabledMode", 
                                        Buffer (One)
                                        {
                                             0x02
                                        }, 

                                        "ATY,EFIHWInitStatus", 
                                        Buffer (0x08)
                                        {
                                             0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
                                        }, 

                                        "ATY,EFIOrientation", 
                                        Buffer (0x02)
                                        {
                                             0x00, 0x01
                                        }, 

                                        "ATY,EFIVersion", 
                                        Buffer (0x0B)
                                        {
                                            "01.00.3180"
                                        }, 

                                        "ATY,EFIVersionB", 
                                        Buffer (0x0F)
                                        {
                                            "113-B77101-012"
                                        }, 

                                        "ATY,EFIVersionE", 
                                        Buffer (0x0F)
                                        {
                                            "113-B7710A-318"
                                        }, 

                                        "ATY,MCLK", 
                                        Buffer (0x04)
                                        {
                                             0xC0, 0xD4, 0x01, 0x00
                                        }, 

                                        "ATY,MemRevisionID", 
                                        Buffer (0x02)
                                        {
                                             0x03, 0x00
                                        }, 

                                        "ATY,MemVendorID", 
                                        Buffer (0x02)
                                        {
                                             0x02, 0x00
                                        }, 

                                        "ATY,PlatformInfo", 
                                        Buffer (0x80)
                                        {
                                            /* 0000 */   0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                            /* 0008 */   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                            /* 0010 */   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                            /* 0018 */   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                            /* 0020 */   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                            /* 0028 */   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                            /* 0030 */   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                            /* 0038 */   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                            /* 0040 */   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                            /* 0048 */   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                            /* 0050 */   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                            /* 0058 */   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                            /* 0060 */   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                            /* 0068 */   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                            /* 0070 */   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                            /* 0078 */   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
                                        }, 

                                        "ATY,Rom#", 
                                        Buffer (0x0F)
                                        {
                                            "113-B7710C-176"
                                        }, 

                                        "ATY,SCLK", 
                                        Buffer (0x04)
                                        {
                                             0x28, 0xDB, 0x0B, 0x00
                                        }, 

                                        "ATY,VendorID", 
                                        Buffer (0x02)
                                        {
                                             0x02, 0x10
                                        }, 

                                        "device_type", 
                                        Buffer (0x11)
                                        {
                                            "ATY,GibbaParent"
                                        }, 

                                        "model", 
                                        Buffer (0x1B)
                                        {
                                            "ATI Radeon HD6950"
                                        }, 

                                        "name", 
                                        Buffer (0x11)
                                        {
                                            "ATY,GibbaParent"
                                        }, 

                                        "hda-gfx", 
                                        Buffer (0x0A)
                                        {
                                            "onboard-1"
                                        }
                                    }, Local0)
                                DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
                                Return (Local0)
                            }
                        }

                        Return (0x80000002)
                    }
                }
            }
